--- old/usr/src/lib/libzfs/common/libzfs_dataset.c	Mon Oct  7 19:17:16 2013
+++ new/usr/src/lib/libzfs/common/libzfs_dataset.c	Mon Oct  7 19:17:16 2013
@@ -1377,6 +1377,12 @@
 			    "property setting is not allowed on "
 			    "bootable datasets"));
 			(void) zfs_error(hdl, EZFS_NOTSUP, errbuf);
+		} else if (prop == ZFS_PROP_CHECKSUM ||
+		    prop == ZFS_PROP_DEDUP) {
+			(void) zfs_error_aux(hdl, dgettext(TEXT_DOMAIN,
+			    "property setting is not allowed on "
+			    "root pools"));
+			(void) zfs_error(hdl, EZFS_NOTSUP, errbuf);
 		} else {
 			(void) zfs_standard_error(hdl, err, errbuf);
 		}
